## ld.so-1.8.10.tar.gz

=== Makefile ===
include Version.mk
include Config.mk

SUBDIRS = man util d-link
ifeq ($(AOUT_SUPPORT),true)
SUBDIRS += ld-so
endif
ifeq ($(ARCH),i386)
SUBDIRS += test
endif

all:
	set -e ; for d in $(SUBDIRS) ; do $(MAKE) -C $$d ; done

install: all
	sh instldso.sh

clean:
	set -e ; for d in $(SUBDIRS) ; do $(MAKE) -C $$d $@ ; done
	-find . -name *~ | xargs rm -f

dist:
	$(MAKE) clean
	$(MAKE) all
	find . -name '*.o' | xargs rm
	cd .. && \
	tar cvf ld.so-$(VERSION).tar ld.so-$(VERSION) && \
	gzip -v9 ld.so-$(VERSION).tar

=== d-link/Makefile ===
include ../Version.mk
include ../Config.mk

DIRS = $(ARCH) libdl

CFLAGS += -I. -I./$(ARCH) -DNO_UNDERSCORE -DVERBOSE_DLINKER \
	-DUSE_CACHE -fPIC -D__PIC__ #-funroll-loops

SRC2S = boot1.c hash.c readelflib1.c vsprintf.c

SRCS	= $(SRC1S) $(SRC2S)
OBJ1S	= $(SRC1S:.S=.o)
OBJ2S	= $(SRC2S:.c=.o)
OBJS	= $(OBJ1S) $(OBJ2S)

DLINKER = ld-linux.so

ELF_LDFLAGS=--shared # using GNU ld
#ELF_LDFLAGS=-G  # with SVr4 ld

lib:: $(OBJS)
	@for i in $(DIRS); do \
	  echo making $@ in $$i; \
	  ($(MAKE) -C $$i $@); \
	done;
	$(LD) -e _dl_boot $(ELF_LDFLAGS) -o $(DLINKER) *.o

obj: $(OBJS)

realclean::
	$(RM) -f .depend $(DLINKER) core *.o *.a *.s *.i tmp_make foo *~

clean::
	$(RM) -f $(DLINKER) core *.o *.a *.s *.i tmp_make foo *~

depend::
	$(CC) $(CFLAGS) -M $(SRCS) | \
		sed -e 's,^[ 	]*\(.*.o\)[ 	]*:,$(STATIC_DIR)/$(SUBDIR)/\1 $(SHARED_DIR)/$(SUBDIR)/\1 $(SHARED_LITE_DIR)/$(SUBDIR)/\1 $(DEBUG_DIR)/$(SUBDIR)/\1 $(PROFILE_DIR)/$(SUBDIR)/\1 $(CHECKER_DIR)/$(SUBDIR)/\1:,' > .depend
#	$(MAKE) subdir TARGET=depend

ifneq ($(DIRS),)
lib realclean clean depend::
	@for i in $(DIRS); do \
	  echo making $@ in $$i; \
	  ($(MAKE) -C $$i $@); \
	done;
endif

#
# include a dependency file if one exists
#
ifeq (.depend,$(wildcard .depend))
include .depend
endif

=== debian/changelog ===
ld.so (1.8.10-1) stable unstable; urgency=low

  * Fixed a bug in ldconfig where a symlink could be used
    instead of a regular file.

  * Fixed a Debian packaging problem for the sparc 
    architecture.

 -- David Engel <david@debian.org>  Tue, 18 Feb 1997 20:49:23 -0600

ld.so (1.8.9-1) unstable; urgency=low

  * Changed ldconfig to only cache the symlinks it creates.
    This make the behavior of the dynamic linkers consistent
     with how they would behave if a cache was not used.

  * Changed ldconfig to cache the symlinks that it finds but
    use the name of the symlink as the soname instead of the 
    actual soname.

 -- David Engel <david@debian.org>  Sun, 9 Feb 1997 00:32:25 -0600

ld.so (1.8.8-1) stable unstable; urgency=low

  * Minor documentation updates to reflect recent changes.

  * Changed ld.so and ld-linux.so to perform more complete
    validation on ld.so.cache before using it.

  * Changed ldconfig to accept libraries with inconsistent
    sonames since glibc is going to use them.  A warning is
    still printed in debug mode.

  * Changed the install script to not strip _dl_debug_state
    from ld-linux.so since gdb needs it.

  * More sparc fixes (Derrick Brashear).

  * Changed ldconfig to not issue a warning when a linker
    script disguised as a shared library is found.

  * Fixed a bug in ld-linux.so where some registers were 
    not preserved on the first call to a function causing 
    problems for non-C-like languages (Tim Renouf).

  * Fixed a bug in ld-linux.so where global variables were 
    not always mapped correctly across dynamically loaded 
    libraries (Mikihiko Nakao).

  * Converted to new Debian source packaging format (Shaya
    Potter).

 -- David Engel <david@debian.org>  Sat, 25 Jan 1997 23:30:10 -0600

Local variables:
mode: debian-changelog
End:

=== debian/control ===
Source: ld.so
Section: base
Priority: required
Maintainer: David Engel <david@debian.org>
Standards-Version: 0.2.1.1

Package: ldso
Section: base
Priority: required
Essential: yes
Architecture: any
Replaces: libc
Provides: libdl1
Description: The Linux dynamic linker, library and utilities.
 The dynamic linker provides the user-level support for loading and
 linking DLL and ELF shared libraries.  It is required by any program
 that uses shared libraries, which is just about all of them.

=== debian/rules ===
#! /usr/bin/make -f
#
# Last updated: Thu Apr 26 22:00:00 CDT 1995 by david.
#
# To make the binary distribution package, the ``Debianized'' source package
# and the context diff to the original package, type `./debian.rules dist'.
# Make sure that `debian.rules' is executable before the final distribution
# is made.
#
# Invoke each target with `./debian.rules <target>'.  All targets should be
# invoked with the package root as the current directory.
#
# The `binary' target must be run as root, as it needs to install files with
# specific ownerships.  The `diff' target assumes that you have the original
# source package available, unpacked, in ../$(p)-$(v).orig, or that you have
# the previous revision of the ``Debianized'' source package and context diff
# in the parent directory.

include Version.mk
p = ld.so
v = $(VERSION)
vm = $(VMAJOR)
arch = $(shell dpkg --print-architecture)

build:
# Builds the binary package.
	make ARCH=$(arch) clean
	make ARCH=$(arch)
	touch build

clean:
# Undoes the effect of `make -f debian.rules build'.
	make ARCH=$(arch) clean
	rm -f build
	rm -rf debian/tmp debian/files

binary-indep:   checkroot build
        $(checkdir)

binary-arch:    checkroot build
	$(checkdir)
	rm -rf debian/tmp
	install -d -m 755 debian/tmp
	chmod g-s debian/tmp
	#
	install -d -m 755 debian/tmp/etc
	install -m 644 debian/ld.so.conf debian/tmp/etc/ld.so.conf
	install -d -m 755 debian/tmp/lib
	if [ -f ld-so/ld.so ]; then \
		install -s -m 755 ld-so/ld.so debian/tmp/lib/ld.so.$(v); \
	fi
	install -m 755 d-link/ld-linux.so debian/tmp/lib/ld-linux.so.$(v)
	strip -g -K _dl_debug_state debian/tmp/lib/ld-linux.so.$(v)
	install -s -m 755 d-link/libdl/libdl.so debian/tmp/lib/libdl.so.$(v)
	ln -sf libdl.so.$(v) debian/tmp/lib/libdl.so.$(vm)
	ln -sf libdl.so.$(v) debian/tmp/lib/libdl.so
	install -d -m 755 debian/tmp/sbin
	install -s -m 755 util/ldconfig debian/tmp/sbin/ldconfig.new
	#
	install -d -m 755 debian/tmp/usr/bin
	install -s -m 755 util/ldd debian/tmp/usr/bin/ldd
	install -d -m 755 debian/tmp/usr/lib
	install -s -m 755 util/lddstub debian/tmp/usr/lib/lddstub
	install -d -m 755 debian/tmp/usr/include
	install -m 644 d-link/libdl/dlfcn.h debian/tmp/usr/include/dlfcn.h
	#
	install -d -m 755 debian/tmp/usr/man/man1
	install -m 644 man/ldd.1 debian/tmp/usr/man/man1/ldd.1
	install -d -m 755 debian/tmp/usr/man/man8
	install -m 644 man/ldconfig.8 debian/tmp/usr/man/man8/ldconfig.8
	install -m 644 man/ld.so.8 debian/tmp/usr/man/man8/ld.so.8
	install -d -m 755 debian/tmp/usr/man/man3
	install -m 644 man/dlopen.3 debian/tmp/usr/man/man3/dlopen.3
	gzip -9 debian/tmp/usr/man/man*/*
	ln -sf dlopen.3.gz debian/tmp/usr/man/man3/dlsym.3.gz
	ln -sf dlopen.3.gz debian/tmp/usr/man/man3/dlerror.3.gz
	ln -sf dlopen.3.gz debian/tmp/usr/man/man3/dlclose.3.gz
	install -d -m 755 debian/tmp/usr/info
	install -m 644 man/ld.so.info debian/tmp/usr/info
	gzip -9 debian/tmp/usr/info/*
	#
	install -d -m 755 debian/tmp/usr/doc/$(p)
	install -m 644 debian/copyright debian/tmp/usr/doc/$(p)/copyright
	install -m 644 README debian/tmp/usr/doc/$(p)/README
	gzip -9f debian/tmp/usr/doc/$(p)/README
	install -m 644 debian/changelog debian/tmp/usr/doc/$(p)/changelog
	gzip -9f debian/tmp/usr/doc/$(p)/changelog
	#
	install -d -m 755 debian/tmp/DEBIAN
	dpkg-gencontrol
	install -m 644 debian/conffiles debian/tmp/DEBIAN/conffiles
	install -m 644 debian/shlibs debian/tmp/DEBIAN/shlibs
	uuencode util/elf-ok elf-ok > /tmp/elf-ok.uue
	sed -e '/^__END__/r /tmp/elf-ok.uue' debian/preinst \
		> debian/tmp/DEBIAN/preinst
	chmod 755 debian/tmp/DEBIAN/preinst
	rm -f /tmp/elf-ok.uue
	sed -e 's/VERSION/$(v)/g' -e 's/VMAJOR/$(vm)/g' debian/postinst \
		> debian/tmp/DEBIAN/postinst
	chmod 755 debian/tmp/DEBIAN/postinst
	install -m 755 debian/prerm debian/tmp/DEBIAN/prerm
	#
	chmod -R g-w debian/tmp
	chown -R root.root debian/tmp
	dpkg --build debian/tmp ..

binary: binary-indep binary-arch

checkroot:
	test root = "`whoami`"

.PHONY: binary binary-arch binary-indep clean checkroot
